// Timer 0 take as interrupt 
// Timer 1 take as delay

#include <reg51.h>

// ŧiɨ禡
void delay_1500ms(void);

unsigned int timer0_counter = 150;

bit lightoff = 1;
bit lighton = 0;
sbit P1_0 = P1^0;
sbit P1_1 = P1^1;
sbit P1_2 = P1^2;
sbit P1_3 = P1^3;
sbit P1_4 = P1^4;
sbit P1_5 = P1^5;
sbit P1_6 = P1^6;
sbit P1_7 = P1^7;

void main(void){
	
	//} Timer0 M Timer1
	TMOD = 0x11;

	//interrupt control 
	TL0 = (65536 - 9216) % 256;
	TH0 = (65536 - 9216) / 256;
	TF0 = 0;
	TR0 = 1;	//}ҭpɾ timer0
	ET0 = 1;	//} TF0 _Ҳն}
	EA = 1;		//}Ҥ_Ҳ`}

	while(1){
	  // do LED move up to down per 1.5 sec
    // using Timer 1 Mode 1 to generate 10ms delay
		P1 = 0xFF;
		while (1) {
			delay_1500ms();
			
			P1_0 = lighton;
			delay_1500ms();
			
			P1_1 = lighton;
			delay_1500ms();
			
			P1_2 = lighton;
			delay_1500ms();
			
			P1_3 = lighton;
			delay_1500ms();
			
			P1_4 = lighton;
			delay_1500ms();
			
			P1_5 = lighton;
			delay_1500ms();
			
			P1_6 = lighton;
			delay_1500ms();
			
			P1_7 = lighton;
			delay_1500ms();
			
			P1_7 = lightoff;
			delay_1500ms();
			
			P1_6 = lightoff;
			delay_1500ms();
			
			P1_5 = lightoff;
			delay_1500ms();
			
			P1_4 = lightoff;
			delay_1500ms();
			
			P1_3 = lightoff;
			delay_1500ms();
			
			P1_2 = lightoff;
			delay_1500ms();
			
			P1_1 = lightoff;
			delay_1500ms();
			
			P1_0 = lightoff;
		} 
	}
}


void delay_1500ms(void){
	
	int time = 0;
	while(time < 150) {
		//]wl
		TF1 = 0;
		TR1 = 0;
		TL1 = (65536-9216) % 256;
		TH1 = (65536-9216) / 256;
		
		//}ҭpɾ timer1
		TR1 = 1;
		
		// TF1 S
		while(TF1 == 0);
		
		//pɾ
		TR1 = 0;
		
		//N TF1 ks
		TF1 = 0;
		time++;
	}
}


// timer0 bpɨ쪺ɭ(TF0 = 1)|Is_ƨ禡
void my_timer0(void) interrupt 1 {
	
	//]wl
	TL0 = (65536 - 9216) % 256;
	TH0 = (65536 - 9216) / 256;
  TF0 = 0;
	
  // timer0_counter @
	timer0_counter--;
	
	
	// timer0_counter  0 ɡA@Cqܾ
  if (timer0_counter == 0){
    // @Cqܾ
		
		
		//N timer0_counter ȳ]^ 150
    timer0_counter = 150;
		
  }
}
